<?php

include_once "init.php";

if (!extension_loaded("sockets"))
{
  include_once "header.php";
  echo '<h1>Query</h1><div style="color: red">Sockets extension is not loaded</div>';
  include_once "footer.php";
  die;
}

$conf = cfg_get();
$port = isset($conf['__ListenPort']) ? $conf['__ListenPort'] : $default_ListenPort;


// ***** Start Output **********************************************************

include_once "header.php";

?>

<h1>Query</h1>

<form action="">
<div>
Username:
<input type="text"   name="user" />
<input type="submit" name="statuser" value=  "User status" />
<input type="submit" name="statserv" value="Server status" />
<input type="submit" name="cntusers" value=  "User count"  />
<input type="submit" name="cntrooms" value=  "Room count"  />
<input type="submit" name="lstusers" value=  "User list"   />
<input type="submit" name="lstrooms" value=  "Room list"   />
<br />
</div>
</form>

<?php

if (isset($_GET['user']))
if (isset($_GET['statuser']) ||
    isset($_GET['statserv']) ||
    isset($_GET['cntusers']) ||
    isset($_GET['cntrooms']) ||
    isset($_GET['lstusers']) ||
    isset($_GET['lstrooms']))
{
  $return = 'failed';
  $socket = @socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
  if ($socket)
  {
    if (@socket_connect($socket, $_SERVER['SERVER_NAME'], $port))
    {
      for ($i = 0; $i < 256; $i++)
      {
        $string = @socket_read($socket, 1024, PHP_NORMAL_READ);
        if ($query_SysCmdLogin  === ord($string[0])) { @socket_read($socket, 1024, PHP_NORMAL_READ); break; }
        if ($query_SysCmdLogoff === ord($string[0])) { @socket_read($socket, 1024, PHP_NORMAL_READ); break; }
      }

      if (isset($_GET['statuser'])) @socket_write($socket, chr($query_StatUser) . $_GET['user'] . "\r\n");
      if (isset($_GET['statserv'])) @socket_write($socket, chr($query_StatServ) . "\r\n");
      if (isset($_GET['cntusers'])) @socket_write($socket, chr($query_CntUsers) . "\r\n");
      if (isset($_GET['cntrooms'])) @socket_write($socket, chr($query_CntRooms) . "\r\n");
      if (isset($_GET['lstusers'])) @socket_write($socket, chr($query_LstUsers) . "\r\n");
      if (isset($_GET['lstrooms'])) @socket_write($socket, chr($query_LstRooms) . "\r\n");

      if (isset($_GET['statuser']) || isset($_GET['cntusers']) || isset($_GET['cntrooms']))
      {
               $return   = htmlentities(trim(@socket_read($socket, 1024, PHP_NORMAL_READ)));
               $return   = $return !== '' ? $return : 'failed';
      }

      if (isset($_GET['statserv']) || isset($_GET['lstusers']) || isset($_GET['lstrooms']))
      {
               $return   = array();
        while ($return[] = htmlentities(trim(@socket_read($socket, 1024, PHP_NORMAL_READ))));
               $return   = implode('<br />', $return);
      }

      for ($i = 0; $i < 001; $i++)
      {
        $string = @socket_read($socket, 1024, PHP_NORMAL_READ);
      }
    }
    @socket_shutdown($socket, 2);
    @socket_close   ($socket);
  }
  echo "<pre>$return</pre>";
}

include_once "footer.php";

?>